t-digest
========

A new data structure for accurate on-line accumulation of rank-based statistics such as quantiles
and trimmed means.  The t-digest algorithm is also very parallel friendly making it useful in
map-reduce and parallel streaming applications.

The t-digest construction algorithm uses a variant of 1-dimensional k-means clustering to product a
data structure that is related to the Q-digest.  This t-digest data structure can be used to estimate
quantiles or compute other rank statistics.  The advantage of the t-digest over the Q-digest is that
the t-digest can handle floating point values while the Q-digest is limited to integers.  With small
changes, the t-digest can handle any values from any ordered set that has something akin to a mean.
The accuracy of quantile estimates produced by t-digests can be orders of magnitude more accurate than
those produced by Q-digests in spite of the fact that t-digests are more compact when stored on disk.

In summary, the particularly interesting characteristics of the t-digest are that it

* has smaller summaries than Q-digest
* works on doubles as well as integers.
* provides part per million accuracy for extreme quantiles and typically <1000 ppm accuracy for middle quantiles
* is fast
* is very simple
* has a reference implementation that has > 90% test coverage
* can be used with map-reduce very easily because digests can be merged

Compile and Test
================

You have to have java 1.7 to compile and run this code.  The special features of Java 1.7 are only lightly used
so you should be able to adapt it to use with Java6 relatively easily.  You will also need maven (3+ preferred)
to compile and test this software.  In order to build the images that go into the theory paper, you will need R.
In order to format the paper, you will need latex.  A pre-built pdf version of the paper is provided.

On ubuntu, you can get the necessary pre-requisites with the following:

    sudo apt-get install  openjdk-7-jdk git maven

Once you have these installed, use this to build and test the software:

    mvn test

Testing Accuracy and Comparing to Q-digest
================

The normal test suite produces a number of diagnostics that describe the scaling and accuracy characteristics of
t-digests.  In order to produce nice visualizations of these properties, you need to have more samples.  To get
this enhanced view, use this command:

    mvn test -DrunSlowTests=true

This will enable a slow scaling test and extend the number of iterations on a number of other tests.  Threading
is used extensively in these tests and all tests run in parallel so running this on a multi-core machine is
indicated. On an 8-core EC2 instance, these tests take about 20 minutes to complete.

The data from these tests are stored in a variety of data files in the root directly.  Some of these files are
quite large.  To visualize the contents of these files, copy all of them into the t-digest-paper directory so
that they are accessible to the R scripts there:

    cp *.?sv docs/theory/t-digest-paper/

At this point you can run the R analysis scripts:

    cd docs/theory/t-digest-paper/
    for i in *.r; do (R --slave -f $i; echo $i complete) & echo $i started; done

Most of these scripts will complete almost instantaneously; one or two will take a few tens of seconds.

The output of these scripts are a collection of PNG image files that can be viewed with any suitable viewer
such as Preview on a Mac.  Many of these images are used as figures in the paper in the same directory with
the R scripts.

data = read.delim("scaling.tsv")
errors = read.delim("error-scaling.tsv")
errors$kb = errors$size/1000

pdf("scaling.pdf", width=6, height=2.5, pointsize=7)
layout(matrix(c(1,2), 1, 2, byrow=T), widths=c(1,1))

old = par(mar=c(5.1,4,2.1,2), lwd=0.2)

plot(size1 ~ compression, data[data$samples==10000,], log='xy',
     xlab=expression(1/delta), ylab="Size (kB)", ylim=c(100,100000),
     cex=1, bg=rgb(0,0,0,0.1), col=rgb(0,0,0,0.1), pch=21,
     yaxt='n')
axis(at=c(100,1000,10000,100000), labels=c("0.1", "1", "10", "100"), side=2)
box()

#points(size1 ~ compression, data[data$samples==100,], log='xy',
#     xlab=expression(1/delta), ylab="Size (kB)", 
#       cex=0.5, bg=rgb(0,0,0,0.1), col=rgb(0,0,0,0.1), pch=21)
#
points(size1 ~ compression, data[data$samples==10,], 
       cex=1, bg=rgb(0,0,0,0.1), col=rgb(0,0,0,0.1), pch=22)

legend(2, 9e4, c("10M samples", "10k samples"), pch=c(21,22)) 

c = seq(2,1100,by=1)
m10 = lm(log(size1) ~ log(compression), data[data$samples==10,])
m100 = lm(log(size1) ~ log(compression), data[data$samples==100,])
m10000 = lm(log(size1) ~ log(compression), data[data$samples==10000,])
lines(c, exp(predict(m10, newdata=data.frame(compression=c))), lty=2, col='lightgray')
#lines(c, exp(predict(m100, newdata=data.frame(compression=c))), lty=2, col='lightgray')
lines(c, exp(predict(m10000, newdata=data.frame(compression=c))), lty=2, col='lightgray')
par(old)

old = par(mar=c(5.1,4.2,2.1,2), lwd=0.2)
plot(size2/1000 ~ samples, data[data$compression==100,], log='x', ylim=c(0,22),
     xlab="Samples (x1000)", ylab="Size (kB)", xaxt='n',
     cex=1, bg=rgb(0,0,0,0.1), col=rgb(0,0,0,0.1), pch=21, main=expression(1/delta == 100))
axis(at=c(10,100,1000,10000), labels=c(10,100,1000,"10,000"), side=1)
points(size1/1000 ~ samples, data[data$compression==100,],
       cex=1, bg=rgb(0,0,0,0.1), col=rgb(0,0,0,0.1), pch=22)
ms2 = lm(size2/1000 ~ log(samples), data[data$compression==100,])
s = seq(10, 10000, by=10)
lines(s, predict(ms2, newdata=data.frame(samples=s)), lty=2, col='lightgray')

ms1 = lm(size1/1000 ~ log(samples), data[data$compression==100,])
lines(s, predict(ms1, newdata=data.frame(samples=s)), lty=2, col='lightgray')

samples = c(10,100,1000,10000)
mpSize = 6*((samples*1000) ^ 0.5 * 4)/1000
lines(samples, mpSize, lty=5, pch=23, type='b', lwd=0.8, col='grey')
points(samples, mpSize, lty=5, pch=23)

#box()

legend(9, 22, c("uncompressed", "compressed", "Munro-Paterson"), pch=c(21,22,23)) 

par(old)

dev.off()

pdf("error-scaling.pdf", width=6, height=2, pointsize=7)
layout(matrix(c(1,2,3), 1, 3, byrow=T), widths=c(1.18,1,1))

for (q in c(0.5, 0.01, 0.001)) {
  if (q == 0.5) {
    old = par(mar=c(5.1,4.5,2.1,2))
  } else {
    old = par(mar=c(5.1,0,2.1,2))
  }
  par(lwd=0.2)
  top = paste("q =", q)
  plot(error ~ kb, errors[errors$q == q,],
       ylim=c(-0.05, 0.05),
       pch=21, bg=rgb(0,0,0,.1), col=rgb(0,0,0,.1), log='x',
       xlab="t-digest size (kB)", ylab="Quantile error", cex.lab=1.5,
       yaxt='n', main=top)
  abline(h=0, col='lightgray')
  abline(h=0.01, col='lightgray', lty=2)
  abline(h=-0.01, col='lightgray', lty=2)

  box()
  if (q == 0.5) {
    axis(side=2)
  }
  text(20, 0.09, paste("q =",q))
  par(old)
}

dev.off()

data = read.delim("merge.tsv")

plotMerge = function(n, yaxt = 's') {
  if (yaxt == 'n') {
    ylab = NA
    old = par(mar=c(4.5,1,3,0.5))
  } else {
    ylab = "Error in quantile (ppm)"
    old = par(mar=c(4.5,5,3,0.5))
  }
  par(lwd=0.2)
  boxplot(e1*1e6 ~ q, at=1:6-0.17, xaxt='n', boxwex=0.25, data[data$type=="quantile" & data$parts == n,],
          ylim=c(-10000, 10000), cex=0.5, yaxt = yaxt,
          col=rgb(0.95, 0.95, 0.95), xlab='Quantile (q)', ylab=ylab)
  boxplot(e2*1e6 ~ q, at=1:6+0.17, xaxt='n', boxwex=0.25, add=T, data[data$type=="quantile" & data$parts == n,],
          col=rgb(0.4, 0.4, 0.4), cex=0.5, yaxt = yaxt)
  axis(side=1, at=1:6, labels=c(0.001, 0.01, 0.1, 0.2, 0.3, 0.5))
  legend(0.5, 10000, c("Direct", "Merged"), fill = c(rgb(0.95, 0.95, 0.95), rgb(0.4, 0.4, 0.4)))
  abline(h=0, col=rgb(0.4, 0.4, 0.4))
  text(1.2, 5000, expression(1/delta == 50))
  title(paste(n, " parts"))
  box()
  par(old)
}

setEPS()
postscript("merge.eps", width=6, height=2.4, pointsize=9)
layout(matrix(c(1,2,3), 1, 3, byrow=T), widths=c(1.15,1,1))

plotMerge(5, 's')
plotMerge(20, 'n')
plotMerge(100, 'n')

dev.off()

errorData = read.delim("errors.csv")

plotError = function(dist, ylim=c(-2000, 2000), yaxt='s', ylab, text) {
  boxplot(1e6*error ~ Q, errorData[errorData$dist==dist,], ylim=ylim,
          xlab="Quantile (q)", ylab=ylab, yaxt=yaxt, boxwex=0.4,
          main = text)
  box()
  abline(h=1000, lty=2)
  abline(h=-1000, lty=2)
}

eldest = par(lwd=0.2)
pdf("error.pdf", width=6, height=3, pointsize=7)
layout(matrix(c(1,2), 1, 2, byrow=T), heights=c(1200, 1200), widths=c(1285,1100))
#plotError('mixture', 'mixture-error.png')
plotError('uniform', ylab="Quantile error (ppm)", text=expression(Uniform))
old = par(mar=c(5.1,0,4.1,2))
plotError('gamma', yaxt='n', ylab=NA, text=expression(Gamma(0.1, 0.1)))
par(old)
  dev.off()
par(eldest)

data = read.delim("sizes.csv")

plotGraph = function(tag, title='', showY=T) {
  n = max(data[data$tag == tag, ]$i)
  i = 1:n
  n2 = n/2

  if (showY) {
    yaxt = 's'
  } else {
    yaxt = 'n'
  }

  plot(actual~q, data[data$tag == tag,], cex=0.2, xaxt='n', xlim=c(0,1), ylim=c(0,1050), xlab='Quantile',
       ylab='Centroid size', yaxt=yaxt, pch=21, col=rgb(0,0,0,0.2), bg=rgb(0,0,0,0.2))
  title(title)
  box()
  axis(side=1, at=c(0,0.25, 0.5, 0.75, 1), labels=c(0.0,0.25,0.5,0.75, 1.0))

  q = seq(0,1,by=0.01)
  lines(q, 1000*4*q*(1-q), col='gray')
}

pdf("sizes.pdf", width=6, height=2.0, pointsize=9)
layout(matrix(c(1,2,3), 1, 3, byrow=T), widths=c(1.21,1,1))
eldest = par(lwd=0.2)
old = par(mar=c(4.1, 4.1, 2.1, 2))
plotGraph("uniform", title=expression("Uniform Distribution"), T)
par(old)
old = par(mar=c(4.1,0,2.1,2))
plotGraph("gamma", title=expression(paste(Gamma(0.1, 0.1), " Distribution")), F)
plotGraph("sequential", title=expression("Sequential Distribution"), F)
par(old)
par(eldest)
  dev.off()
#plotGraph("mixture", title="Mixture Distribution")

plotCellHist = function(deviation, plot, title) {
  hist(deviation$deviation, breaks=seq(-5,5,by=0.1), main=title, xlab=NA, ylab=NA,
       col='grey', xlim=c(-1.0, 1.0), border=NA)
  abline(v=-0.5, lty=2)
  abline(v=0.5, lty=2)
}

deviation = read.delim("deviation.csv")
pdf("deviation.pdf", width=6, height=1.8, pointsize=10)
layout(matrix(c(1,2,3), 1, 3, byrow=T), heights=c(700,200))
#layout.show(4)
old = par(mar=c(2.5,2,3,0.5), lwd=0.2)
plotCellHist(deviation[deviation$tag == "uniform" & deviation$Q > 0.3 & deviation$Q < 0.7,], "uniform-deviation.png", "Uniform q=0.3 ... 0.7")
plotCellHist(deviation[deviation$tag == "gamma" & deviation$Q > 0.3 & deviation$Q < 0.7,], "gamma-deviation.png", "Gamma(0.1, 0.1) q=0.3 ... 0.7")

plotCellHist(deviation[deviation$tag == "gamma" & deviation$mean > 0.01 & deviation$mean < 0.015,], "gamma-low.png", "Gamma, q=0.01")
par(old)
dev.off()
